import requests
from requests import Response, Request, Session

import urls

class Client:
    def __init__(self, url: str):
        self.url: str = url
        self.token: str = None
        self.session: Session = Session()
    
    def is_authentificate(self):
        return (not self.token is None)
    
    def login(self, username: str, password: str):
        response: Response = self._post(urls.accounts_login_url, {'username': username, 'password': password})
        return response.content
    
    def register(self, username: str, password: str):
        response: Response = self._post(urls.accounts_register_url, {'username': username, 'password': password})
        return response
    
    def _post(self, uri: str, data: dict):
        url: str = self.url + uri
        if self.token is None:
            response: Response = self.session.get(url)
            self.token = response.cookies['csrftoken']
        data.update({'csrfmiddlewaretoken': self.token})
        response: Response = self.session.post(url, data = data, headers = dict(Referer=url))
        return response.content